# SRC/dgstrsL.c File Reference

Performs the L-solve using the LU factorization computed by DGSTRF. More...

`#include "slu_ddefs.h"`
`#include "slu_util.h"`

## Functions
void | dusolve (int, int, double *, double *)
| Solves a dense upper triangular system.
void | dlsolve (int, int, double *, double *)
| Solves a dense UNIT lower triangular system.
void | dmatvec (int, int, int, double *, double *, double *)
| Performs a dense matrix-vector multiply: Mxvec = Mxvec + M * vec.
void | dgstrsL (char *trans, SuperMatrix *L, int *perm_r, SuperMatrix *B, int *info)
void | dprint_soln (int n, int nrhs, double *soln)

## Detailed Description

     -- SuperLU routine (version 2.0) --
     Univ. of California Berkeley, Xerox Palo Alto Research Center,
     and Lawrence Berkeley National Lab.
     September 15, 2003

     Copyright (c) 1994 by Xerox Corporation.  All rights reserved.

     THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
     EXPRESSED OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.

     Permission is hereby granted to use or copy this program for any
     purpose, provided the above notices are retained on all copies.
     Permission to modify the code and to distribute modified code is
     granted, provided the above notices are retained, and a notice that
     the code was modified is included with the above copyright notice.

## Function Documentation

void dgstrsL | ( | char * | trans,
|  | SuperMatrix * | L,
|  | int * | perm_r,
|  | SuperMatrix * | B,
|  | int * | info |
| ) |  |  |

     Purpose
     =======

     dgstrsL only performs the L-solve using the LU factorization computed
     by DGSTRF.

     See supermatrix.h for the definition of 'SuperMatrix' structure.

     Arguments
     =========

     trans   (input) char*
              Specifies the form of the system of equations:
              = 'N':  A * X = B  (No transpose)
              = 'T':  A'* X = B  (Transpose)
              = 'C':  A**H * X = B  (Conjugate transpose)

     L       (input) SuperMatrix*
             The factor L from the factorization Pr*A*Pc=L*U as computed by
             dgstrf(). Use compressed row subscripts storage for supernodes,
             i.e., L has types: Stype = SLU_SC, Dtype = SLU_D, Mtype = SLU_TRLU.

     U       (input) SuperMatrix*
             The factor U from the factorization Pr*A*Pc=L*U as computed by
             dgstrf(). Use column-wise storage scheme, i.e., U has types:
             Stype = SLU_NC, Dtype = SLU_D, Mtype = SLU_TRU.

     perm_r  (input) int*, dimension (L->nrow)
             Row permutation vector, which defines the permutation matrix Pr;
             perm_r[i] = j means row i of A is in position j in Pr*A.

     B       (input/output) SuperMatrix*
             B has types: Stype = SLU_DN, Dtype = SLU_D, Mtype = SLU_GE.
             On entry, the right hand side matrix.
             On exit, the solution matrix if info = 0;

     info    (output) int*
     	   = 0: successful exit
    	   < 0: if info = -i, the i-th argument had an illegal value

void dlsolve | ( | int | ldm,
|  | int | ncol,
|  | double * | M,
|  | double * | rhs |
| ) |  |  |

The unit lower triangular matrix is stored in a 2D array M(1:nrow,1:ncol). The solution will be returned in the rhs vector.

void dmatvec | ( | int | ldm,
|  | int | nrow,
|  | int | ncol,
|  | double * | M,
|  | double * | vec,
|  | double * | Mxvec |
| ) |  |  |

The input matrix is M(1:nrow,1:ncol); The product is returned in Mxvec[].

void dprint_soln | ( | int | n,
|  | int | nrhs,
|  | double * | soln |
| ) |  |  |

void dusolve | ( | int | ldm,
|  | int | ncol,
|  | double * | M,
|  | double * | rhs |
| ) |  |  |

The upper triangular matrix is stored in a 2-dim array M(1:ldm,1:ncol). The solution will be returned in the rhs vector.